---
title: XMLHttpRequest.sendAsBinary()
slug: Web/API/XMLHttpRequest/sendAsBinary
tags:
  - Binary Data
  - HTTP
  - Method
  - Non-standard
  - Obsolete
  - Reference
  - Sending Binary Data
  - XHR
  - XMLHttpRequest
  - sendAsBinary
---
<div>{{APIRef('XMLHttpRequest')}}</div>

<p><span class="seoSummary">The obsolete {{domxref("XMLHttpRequest")}} method <code><strong>sendAsBinary()</strong></code> is a variant of the {{domxref("XMLHttpRequest.send", "send()")}} method that sends binary data. The <code>send()</code> method now supports binary data and should now be used instead.</span></p>

<p>This method makes it possible to <a href="/en-US/docs/Web/API/XMLHttpRequest/Using_XMLHttpRequest#Submitting_forms_and_uploading_files">read and <strong>upload</strong> any type of file</a> and to <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/JSON/stringify">stringify</a> the raw data.</p>

<div class="warning">
<p><strong>Warning:</strong> This method is obsolete and should not be used. You should instead use the <code>send()</code> method, which now supports binary data in various forms.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>XMLHttpRequest</em>.sendAsBinary(<em>binaryString</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>binaryString</code></dt>
 <dd>A {{domxref("DOMString")}} which encodes the binary content to be sent. You can create the binary string using the {{domxref("FileReader")}} method {{domxref("FileRequest.readAsBinaryString", "readAsBinaryString()")}}. The string is converted to binary for transfer by removing the high-order byte of each character.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p><code>undefined</code>.</p>

<h2 id="Polyfill">Polyfill</h2>

<p>Since <code>sendAsBinary()</code> is an experimental feature, here is <strong>a polyfill</strong> for browsers that <em>don't</em> support the <code>sendAsBinary()</code> method but support <a href="/en-US/docs/Web/JavaScript/Typed_arrays">typed arrays</a>.</p>

<pre class="brush: js">/*\
|*|
|*|  :: XMLHttpRequest.prototype.sendAsBinary() Polyfill ::
|*|
|*|  https://developer.mozilla.org/en-US/docs/DOM/XMLHttpRequest#sendAsBinary()
|*|
\*/

if (!XMLHttpRequest.prototype.sendAsBinary) {
  XMLHttpRequest.prototype.sendAsBinary = function (sData) {
    var nBytes = sData.length, ui8Data = new Uint8Array(nBytes);
    for (var nIdx = 0; nIdx &lt; nBytes; nIdx++) {
      ui8Data[nIdx] = sData.charCodeAt(nIdx) &amp; 0xff;
    }
    /* send as ArrayBufferView...: */
    this.send(ui8Data);
    /* ...or as ArrayBuffer (legacy)...: this.send(ui8Data.buffer); */
  };
}</pre>

<div class="note"><strong>Note:</strong> It's possible to build this polyfill putting two types of data as argument for <code>send()</code>: an <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/ArrayBuffer"><code>ArrayBuffer</code></a> (<code>ui8Data.buffer</code> – the commented code) or an <a href="/en-US/docs/Web/API/ArrayBufferView"><code>ArrayBufferView</code></a> (<code>ui8Data</code>, which is a <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Uint8Array">typed array of 8-bit unsigned integers</a> – uncommented code). However, on Google Chrome, when you try to send an <code>ArrayBuffer</code>, the following warning message will appear: <code>ArrayBuffer is deprecated in XMLHttpRequest.send(). Use ArrayBufferView instead.</code> Another possible approach to send binary data is the <a href="/en-US/Add-ons/Code_snippets/StringView"><code>StringView</code></a> <span class="inlineIndicator" style="background-color: #ffffff;" title="This API is not native.">Non native</span> typed arrays superclass in conjunction with the <a href="#send()"><code>send()</code></a> method.</div>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XMLHttpRequest.sendAsBinary")}}</p>

<ul>
 <li><a href="/en-US/docs/Web/API/XMLHttpRequest/Using_XMLHttpRequest">Using XMLHttpRequest</a></li>
</ul>
